<?php
  $config = array(
    'mysqlHost'=>'localhost',
    'mysqlDB'=>'dico',
    'mysqlLogin'=>'', // <-- À PRÉCISER
    'mysqlPassword'=>'' // <-- À PRÉCISER
  );
  
  $connex = getDBConnexion($config);
  
 
  /**
    Crée et initialise la table dico dans la base de données.
    La base de données doit être préalablement créée et son nom (par défaut 'dico') indiqué dans $config.
    La base de données doit être vide (aucune table).
  */
  function createTable($connex) { 
    $handle = fopen('dbnary-fr.sql', 'r') or die('Impossible d\'ouvrir dbnary-fr.sql .');
    $req = '';
    while(!feof($handle)) {
      $req .= fread($handle, 8192);
      if(substr($req, -1) == ';') {
        $connex->exec($req);
        $req = '';
      }
    }
    fclose($handle);
  }
  
  /**
    Ajoute un mot dans la base de données.
  */
  function addWord($connex, $word, $definition, $valide) {
    $connex->prepare('INSERT INTO `dico` (mot, definition, valide) VALUES (?,?,?)')->execute(array($word, $definition, $valide));
  }
  
  /**
    Retourne l'id d'un mot validé, choisi au hasard.
  */
  function getRandomWordId($connex) {
    $res = $connex->query('SELECT MAX(id) FROM `dico`')->fetch(PDO::FETCH_ASSOC);
    $max = $res['MAX(id)'];
    $word = array();
    do {  // On cherche un mot qui (1) existe dans la base et (2) est validé.
      $id = rand(1, $max);
      $word = $connex->query("SELECT * FROM `dico` WHERE id=$id")->fetch(PDO::FETCH_ASSOC);
    } while(!$word['valide']);
    return $word['id'];
  }

  /**
    Retourne dans un tableau associatif toutes les données sur un mot. Exemple:
      [id] => 99989 
      [mot] => porté 
      [definition] => Figure où l’un des danseurs porte son partenaire au-dessus de lui. 
      [valide] => 1 
      [dateCreation] => 2012-12-09 18:41:04
  */
  function getWordDataById($connex, $id) {
    return $connex->query("SELECT * FROM `dico` WHERE id=".$connex->quote($id))->fetch(PDO::FETCH_ASSOC);
  }
  
  /**
    Change la validité (1 ou 0) d'un mot dont on donne l'id.
  */
  function validateWord($connex, $id, $newValide) {
    $connex->query("UPDATE `dico` SET valide=".$connex->quote($newValide)." WHERE id=".$connex->quote($id));
  }
  
  /**
    Supprime un mot de la base.
  */
  function removeWord($connex, $id) {
    $connex->query("DELETE FROM `dico` WHERE id=".$connex->quote($id));
  }
  
  /**
    Crée une connexion à la base de données et la retourne.
  */
  function getDBConnexion($config) {    
    $connex = new PDO('mysql:host='.$config['mysqlHost'].';dbname='.$config['mysqlDB'], $config['mysqlLogin'], $config['mysqlPassword'], array(PDO::MYSQL_ATTR_INIT_COMMAND => 'SET NAMES \'UTF8\'')); 
    if(!$connex)
      die('Impossible de se connecter à la base.');
    return $connex;
  }  


?>
